// WARNING: generated by kopium - manual changes will be overwritten
// kopium command: kopium -f volumegroupsnapshotcontents.yml --schema=derived --docs -b --derive=Default --derive=PartialEq --smart-derive-elision
// kopium version: 0.21.1

#[allow(unused_imports)]
mod prelude {
    pub use k8s_openapi::api::core::v1::ObjectReference;
    pub use kube_derive::CustomResource;
    #[cfg(feature = "schemars")]
    pub use schemars::JsonSchema;
    pub use serde::{Deserialize, Serialize};
    #[cfg(feature = "builder")]
    pub use typed_builder::TypedBuilder;
}
use self::prelude::*;

/// Spec defines properties of a VolumeGroupSnapshotContent created by the underlying storage system.
/// Required.
#[derive(CustomResource, Serialize, Deserialize, Clone, Debug, PartialEq)]
#[cfg_attr(feature = "builder", derive(TypedBuilder))]
#[cfg_attr(feature = "schemars", derive(JsonSchema))]
#[cfg_attr(not(feature = "schemars"), kube(schema = "disabled"))]
#[kube(
    group = "groupsnapshot.storage.k8s.io",
    version = "v1beta1",
    kind = "VolumeGroupSnapshotContent",
    plural = "volumegroupsnapshotcontents"
)]
#[kube(status = "VolumeGroupSnapshotContentStatus")]
#[kube(derive = "PartialEq")]
pub struct VolumeGroupSnapshotContentSpec {
    /// DeletionPolicy determines whether this VolumeGroupSnapshotContent and the
    /// physical group snapshot on the underlying storage system should be deleted
    /// when the bound VolumeGroupSnapshot is deleted.
    /// Supported values are "Retain" and "Delete".
    /// "Retain" means that the VolumeGroupSnapshotContent and its physical group
    /// snapshot on underlying storage system are kept.
    /// "Delete" means that the VolumeGroupSnapshotContent and its physical group
    /// snapshot on underlying storage system are deleted.
    /// For dynamically provisioned group snapshots, this field will automatically
    /// be filled in by the CSI snapshotter sidecar with the "DeletionPolicy" field
    /// defined in the corresponding VolumeGroupSnapshotClass.
    /// For pre-existing snapshots, users MUST specify this field when creating the
    /// VolumeGroupSnapshotContent object.
    /// Required.
    #[serde(rename = "deletionPolicy")]
    pub deletion_policy: VolumeGroupSnapshotContentDeletionPolicy,
    /// Driver is the name of the CSI driver used to create the physical group snapshot on
    /// the underlying storage system.
    /// This MUST be the same as the name returned by the CSI GetPluginName() call for
    /// that driver.
    /// Required.
    pub driver: String,
    /// Source specifies whether the snapshot is (or should be) dynamically provisioned
    /// or already exists, and just requires a Kubernetes object representation.
    /// This field is immutable after creation.
    /// Required.
    pub source: VolumeGroupSnapshotContentSource,
    /// VolumeGroupSnapshotClassName is the name of the VolumeGroupSnapshotClass from
    /// which this group snapshot was (or will be) created.
    /// Note that after provisioning, the VolumeGroupSnapshotClass may be deleted or
    /// recreated with different set of values, and as such, should not be referenced
    /// post-snapshot creation.
    /// For dynamic provisioning, this field must be set.
    /// This field may be unset for pre-provisioned snapshots.
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "volumeGroupSnapshotClassName"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub volume_group_snapshot_class_name: Option<String>,
    /// VolumeGroupSnapshotRef specifies the VolumeGroupSnapshot object to which this
    /// VolumeGroupSnapshotContent object is bound.
    /// VolumeGroupSnapshot.Spec.VolumeGroupSnapshotContentName field must reference to
    /// this VolumeGroupSnapshotContent's name for the bidirectional binding to be valid.
    /// For a pre-existing VolumeGroupSnapshotContent object, name and namespace of the
    /// VolumeGroupSnapshot object MUST be provided for binding to happen.
    /// This field is immutable after creation.
    /// Required.
    #[serde(rename = "volumeGroupSnapshotRef")]
    pub volume_group_snapshot_ref: ObjectReference,
}

/// Spec defines properties of a VolumeGroupSnapshotContent created by the underlying storage system.
/// Required.
#[derive(Serialize, Deserialize, Clone, Debug, PartialEq)]
#[cfg_attr(feature = "schemars", derive(JsonSchema))]
pub enum VolumeGroupSnapshotContentDeletionPolicy {
    Delete,
    Retain,
}

/// Source specifies whether the snapshot is (or should be) dynamically provisioned
/// or already exists, and just requires a Kubernetes object representation.
/// This field is immutable after creation.
/// Required.
#[derive(Serialize, Deserialize, Clone, Debug, Default, PartialEq)]
#[cfg_attr(feature = "builder", derive(TypedBuilder))]
#[cfg_attr(feature = "schemars", derive(JsonSchema))]
pub struct VolumeGroupSnapshotContentSource {
    /// GroupSnapshotHandles specifies the CSI "group_snapshot_id" of a pre-existing
    /// group snapshot and a list of CSI "snapshot_id" of pre-existing snapshots
    /// on the underlying storage system for which a Kubernetes object
    /// representation was (or should be) created.
    /// This field is immutable.
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "groupSnapshotHandles"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub group_snapshot_handles: Option<VolumeGroupSnapshotContentSourceGroupSnapshotHandles>,
    /// VolumeHandles is a list of volume handles on the backend to be snapshotted
    /// together. It is specified for dynamic provisioning of the VolumeGroupSnapshot.
    /// This field is immutable.
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "volumeHandles"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub volume_handles: Option<Vec<String>>,
}

/// GroupSnapshotHandles specifies the CSI "group_snapshot_id" of a pre-existing
/// group snapshot and a list of CSI "snapshot_id" of pre-existing snapshots
/// on the underlying storage system for which a Kubernetes object
/// representation was (or should be) created.
/// This field is immutable.
#[derive(Serialize, Deserialize, Clone, Debug, Default, PartialEq)]
#[cfg_attr(feature = "builder", derive(TypedBuilder))]
#[cfg_attr(feature = "schemars", derive(JsonSchema))]
pub struct VolumeGroupSnapshotContentSourceGroupSnapshotHandles {
    /// VolumeGroupSnapshotHandle specifies the CSI "group_snapshot_id" of a pre-existing
    /// group snapshot on the underlying storage system for which a Kubernetes object
    /// representation was (or should be) created.
    /// This field is immutable.
    /// Required.
    #[serde(rename = "volumeGroupSnapshotHandle")]
    pub volume_group_snapshot_handle: String,
    /// VolumeSnapshotHandles is a list of CSI "snapshot_id" of pre-existing
    /// snapshots on the underlying storage system for which Kubernetes objects
    /// representation were (or should be) created.
    /// This field is immutable.
    /// Required.
    #[serde(rename = "volumeSnapshotHandles")]
    #[cfg_attr(feature = "builder", builder(default))]
    pub volume_snapshot_handles: Vec<String>,
}

/// VolumeGroupSnapshotRef specifies the VolumeGroupSnapshot object to which this
/// VolumeGroupSnapshotContent object is bound.
/// VolumeGroupSnapshot.Spec.VolumeGroupSnapshotContentName field must reference to
/// this VolumeGroupSnapshotContent's name for the bidirectional binding to be valid.
/// For a pre-existing VolumeGroupSnapshotContent object, name and namespace of the
/// VolumeGroupSnapshot object MUST be provided for binding to happen.
/// This field is immutable after creation.
/// Required.
#[derive(Serialize, Deserialize, Clone, Debug, Default, PartialEq)]
#[cfg_attr(feature = "builder", derive(TypedBuilder))]
#[cfg_attr(feature = "schemars", derive(JsonSchema))]
pub struct VolumeGroupSnapshotContentVolumeGroupSnapshotRef {
    /// API version of the referent.
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "apiVersion"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub api_version: Option<String>,
    /// If referring to a piece of an object instead of an entire object, this string
    /// should contain a valid JSON/Go field access statement, such as desiredState.manifest.containers[2].
    /// For example, if the object reference is to a container within a pod, this would take on a value like:
    /// "spec.containers{name}" (where "name" refers to the name of the container that triggered
    /// the event) or if no container name is specified "spec.containers[2]" (container with
    /// index 2 in this pod). This syntax is chosen only to have some well-defined way of
    /// referencing a part of an object.
    /// TODO: this design is not final and this field is subject to change in the future.
    #[serde(default, skip_serializing_if = "Option::is_none", rename = "fieldPath")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub field_path: Option<String>,
    /// Kind of the referent.
    /// More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub kind: Option<String>,
    /// Name of the referent.
    /// More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub name: Option<String>,
    /// Namespace of the referent.
    /// More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub namespace: Option<String>,
    /// Specific resourceVersion to which this reference is made, if any.
    /// More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#concurrency-control-and-consistency
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "resourceVersion"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub resource_version: Option<String>,
    /// UID of the referent.
    /// More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#uids
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub uid: Option<String>,
}

/// status represents the current information of a group snapshot.
#[derive(Serialize, Deserialize, Clone, Debug, Default, PartialEq)]
#[cfg_attr(feature = "builder", derive(TypedBuilder))]
#[cfg_attr(feature = "schemars", derive(JsonSchema))]
pub struct VolumeGroupSnapshotContentStatus {
    /// CreationTime is the timestamp when the point-in-time group snapshot is taken
    /// by the underlying storage system.
    /// If not specified, it indicates the creation time is unknown.
    /// If not specified, it means the readiness of a group snapshot is unknown.
    /// The format of this field is a Unix nanoseconds time encoded as an int64.
    /// On Unix, the command date +%s%N returns the current time in nanoseconds
    /// since 1970-01-01 00:00:00 UTC.
    /// This field is the source for the CreationTime field in VolumeGroupSnapshotStatus
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "creationTime"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub creation_time: Option<String>,
    /// Error is the last observed error during group snapshot creation, if any.
    /// Upon success after retry, this error field will be cleared.
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub error: Option<VolumeGroupSnapshotContentStatusError>,
    /// ReadyToUse indicates if all the individual snapshots in the group are ready to be
    /// used to restore a group of volumes.
    /// ReadyToUse becomes true when ReadyToUse of all individual snapshots become true.
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "readyToUse"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub ready_to_use: Option<bool>,
    /// VolumeGroupSnapshotHandle is a unique id returned by the CSI driver
    /// to identify the VolumeGroupSnapshot on the storage system.
    /// If a storage system does not provide such an id, the
    /// CSI driver can choose to return the VolumeGroupSnapshot name.
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "volumeGroupSnapshotHandle"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub volume_group_snapshot_handle: Option<String>,
    /// VolumeSnapshotHandlePairList is a list of CSI "volume_id" and "snapshot_id"
    /// pair returned by the CSI driver to identify snapshots and their source volumes
    /// on the storage system.
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "volumeSnapshotHandlePairList"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub volume_snapshot_handle_pair_list:
        Option<Vec<VolumeGroupSnapshotContentStatusVolumeSnapshotHandlePairList>>,
}

/// Error is the last observed error during group snapshot creation, if any.
/// Upon success after retry, this error field will be cleared.
#[derive(Serialize, Deserialize, Clone, Debug, Default, PartialEq)]
#[cfg_attr(feature = "builder", derive(TypedBuilder))]
#[cfg_attr(feature = "schemars", derive(JsonSchema))]
pub struct VolumeGroupSnapshotContentStatusError {
    /// message is a string detailing the encountered error during snapshot
    /// creation if specified.
    /// NOTE: message may be logged, and it should not contain sensitive
    /// information.
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub message: Option<String>,
    /// time is the timestamp when the error was encountered.
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub time: Option<String>,
}

/// VolumeSnapshotHandlePair defines a pair of a source volume handle and a snapshot handle
#[derive(Serialize, Deserialize, Clone, Debug, Default, PartialEq)]
#[cfg_attr(feature = "builder", derive(TypedBuilder))]
#[cfg_attr(feature = "schemars", derive(JsonSchema))]
pub struct VolumeGroupSnapshotContentStatusVolumeSnapshotHandlePairList {
    /// SnapshotHandle is a unique id returned by the CSI driver to identify a volume
    /// snapshot on the storage system
    /// Required.
    #[serde(rename = "snapshotHandle")]
    pub snapshot_handle: String,
    /// VolumeHandle is a unique id returned by the CSI driver to identify a volume
    /// on the storage system
    /// Required.
    #[serde(rename = "volumeHandle")]
    pub volume_handle: String,
}
